//
// System.Net.Radius.radiusauth.cs
//
// Author:
//  Cyrille Colin (colin@univ-metz.fr)
//
// Copyright (C) Cyrille COLIN, 2005
//

//
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject to
// the following conditions:
//
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
// NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
// LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
// OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//


using System;
namespace System.Net.Radius {
	class test {
		static void Main(string[] args) {
			if(args.Length!=4){
				ShowUsage();
				return;
			}
			try {
				RadiusClient rc = new RadiusClient(args[0],args[1]);
				RadiusPacket authPacket = rc.Authenticate(args[2],args[3]);
				RadiusPacket receivedPacket = rc.SendAndReceivePacket(authPacket);
				if(receivedPacket == null) throw new Exception ("Can't contact remote radius server !");		
				switch (receivedPacket.Type) {
					case RadiusPacketType.ACCESS_ACCEPT :
						   Console.WriteLine("accepted");
						   foreach (RadiusAttribute attr in receivedPacket.Attributes) {
								Console.WriteLine(attr.Type.ToString()+ " = " + attr.Value);
						   }
					   	break;
				 	default :
							Console.WriteLine("rejected");
						break;		
				}
			} catch (Exception e) {
				Console.WriteLine("Error : "+e.Message);
			}
		}
		private static void ShowUsage() {
			Console.WriteLine("Usage : mono radiusauth.exe hostname sharedsecret username password");
		}
	}
}
